//+------------------------------------------------------------------+
//|                                                           T3.mq4 |
//|                              Copyright  2005,            MojoFX | 
//|  http://groups.yahoo.com/group/MetaTrader_Experts_and_Indicators | 
//+------------------------------------------------------------------+
////nk http://articles.mql4.com/ru/139
#property copyright "MojoFX - Conversion only"
#property link "http://groups.yahoo.com/group/MetaTrader_Experts_and_Indicators/"
#property indicator_chart_window
#property indicator_buffers  1
#property indicator_color1  Yellow 
//---- 
extern int  T3_Period = 8;  
extern double b = 0.7;
//---- 
//---- 
double MapBuffer[];
//----  
double e1,e2,e3,e4,e5,e6;
double n,c1,c2,c3,c4,w1,w2,b2,b3;
//----       e1,e2,e3,e4,e5,e6
int time2; double E1,E2,E3,E4,E5,E6;
//+------------------------------------------------------------------+ 
//|  T3 initialization function                                      |
//+------------------------------------------------------------------+
int init()
{
//---- indicators setting
SetIndexStyle(0,DRAW_LINE);
IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS));
IndicatorShortName("T3"+T3_Period);
SetIndexBuffer(0,MapBuffer);
b2=b*b;
b3=b2*b;
c1=-b3;
c2=(3*(b2+b3));
c3=-3*(2*b2+b+b3);
c4=(1+3*b+b3+3*b2);
if (T3_Period<1) T3_Period=1;
n = 1 + 0.5*(T3_Period-1);
w1 = 2 / (n + 1);
w2 = 1 - w1;
//----  
return(0);
}

//+------------------------------------------------------------------+
//| T3 iteration function                                            |
//+------------------------------------------------------------------+
int start()
{
//----+         
if (Bars-1<T3_Period)return(0);
//----+        
int MaxBar,limit,counted_bars=IndicatorCounted();
//----    
if (counted_bars<0)return(-1);
//----      
if (counted_bars>0) counted_bars--;
//----     ,        
MaxBar=Bars-1-T3_Period;
//----     ,         
limit=(Bars-1-counted_bars);
//----  
if (limit>MaxBar)
  {
   for(int bar=Bars-1; bar>=MaxBar; bar--)MapBuffer[bar]=0.0;
   limit=MaxBar; 
  }
//+---        ,        
//+---    +=======+
int Tnew=Time[limit+1];
if (limit<MaxBar)
 if (Tnew==time2)
   {
    e1=E1; e2=E2; e3=E3; e4=E4; e5=E5; e6=E6;  
   }
 else 
   {
    if (Tnew>time2)Print("ERROR01");
    else Print("ERROR02");
    return(-1);
   }
//+--- +==========================================+

//+---    
for(bar=limit; bar>=0; bar--)
 {
  //+---   ,      
  //+---    +=============+ 
  if (bar==1)
       if(((limit==1)&&(time2!=Time[2]))||(limit>1))
        {
         time2=Time[2];
         E1=e1; E2=e2; E3=e3; E4=e4; E5=e5; E6=e6;
        }
  //+---+============================================+
  e1 = w1*Close[bar] + w2*e1;
  e2 = w1*e1 + w2*e2;
  e3 = w1*e2 + w2*e3;
  e4 = w1*e3 + w2*e4;
  e5 = w1*e4 + w2*e5;
  e6 = w1*e5 + w2*e6;
  MapBuffer[bar]=c1*e6 + c2*e5 + c3*e4 + c4*e3;
 } 
//+---   
return(0);
}
//+-----------------------------------------------------------------------------+